#! /usr/bin/python
# -*- coding: utf-8 -*-
import unifier
from importer.Argument import SemanticRole
from semantics.models import FrameOpinion
import semantics.models
from unifier.models import UnifiedFrameArgument, UnifiedFrame, UnifiedFrame2SlowalFrameMapping, \
    UnifiedFrameArgumentSlowalFrameMapping


class UnifiedFrameImport:

    @classmethod
    def storeAndGetRoleType(self, type):
        role_type = semantics.models.RoleType.objects.get(type=type)
        return role_type

    @classmethod
    def storeUnifiedFrameArgument(cls, tree, unifiedFrame):
        id = tree._attrs['id']
        attribute = None
        semantic_roles = []

        for subtree in tree._children:
            if subtree._name == 'semantic_role':
                role_type = subtree._attrs['type']
            elif subtree._name == 'roles':
                for value in subtree._children:
                    role = value._attrs['name']
                    semantic_role = SemanticRole(role, attribute)
                    semantic_roles.append(semantic_role)
            else:
                print(subtree._attrs['name'])
                raise UnknownError()

        role_type_obj = UnifiedFrameImport.storeAndGetRoleType(role_type)
        role_type_obj.save()
        argument = UnifiedFrameArgument(pk=int(id),
                                        role_type=role_type_obj,
                                        unified_frame=unifiedFrame)
        argument.proposed_roles.set([])
        argument.role = None
        argument.save()
        for semantic_role in semantic_roles:
            semantic_roles_obj = semantic_role.store()
            semantic_roles_obj.save()
            argument.proposed_roles.add(semantic_roles_obj)
        argument.save()

    @classmethod
    def storeSlowalFrame(cls, tree, unifiedFrame):
        slowal_frame_id = tree._attrs['id']

        unifiedFrame2SlowalFrameMapping = UnifiedFrame2SlowalFrameMapping(unified_frame=unifiedFrame,
                                                                        slowal_frame_id=slowal_frame_id)
        unifiedFrame2SlowalFrameMapping.save()

        for subtree in tree._children:
            if subtree._name == 'arguments_connections':
                for subsubtree in subtree._children:
                    if subsubtree._name == 'arguments_connection':
                        unifier_argument_id = subsubtree._attrs['unifier_argument_id']
                        slowal_id = subsubtree._attrs['slowal_id']
                        unifiedFrameArgumentSlowalFrameMapping = UnifiedFrameArgumentSlowalFrameMapping(unified_frame_mapping=unifiedFrame2SlowalFrameMapping,
                                                                                                      unified_agrument_id=unifier_argument_id,
                                                                                                      slowal_agrument_id=slowal_id)
                        unifiedFrameArgumentSlowalFrameMapping.save()

    @classmethod
    def storeUnifiedFrame(cls, frame_tree):

        unifiedFrame = UnifiedFrame()
        unifiedFrame.save()

        for node in frame_tree._children:
            if node._name == 'argument':
                UnifiedFrameImport.storeUnifiedFrameArgument(node, unifiedFrame)
            if node._name == 'connections':
                for subnode in node._children:
                    if subnode._name == 'slowal_frame':
                        UnifiedFrameImport.storeSlowalFrame(subnode, unifiedFrame)

